<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/

class p_load_more extends cmsPlugin {

// ==================================================================== //

    public function __construct(){
        
        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_load_more';
        $this->info['title']            = 'Плагин Автоподгрузка';
        $this->info['description']      = 'Добавляет контент следующих страниц по мере пролистывания страницы';
        $this->info['author']           = 'lokanaft';
        $this->info['version']          = '1.0b3';

        // Настройки по-умолчанию

        $this->config['Компоненты через запятую']               = 'forum,blogs,board,content';
        $this->config['Разрешить прекращать подгрузку']         = 1;
        $this->config['Отступ сверху до появления PageBar']     = 150;
        $this->config['Осталось пикселей для начала загрузки']  = 300;

        // События, которые будут отлавливаться плагином

        $this->events[]                 = 'GET_PAGEBAR';
        $this->events[]                 = 'AFTER_COMPONENT';

    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){
        parent::execute();
        switch ($event){
            case 'GET_PAGEBAR': $item = $this->eventGetPagebar($item); break;
            case 'AFTER_COMPONENT': $item = $this->eventAfterComponent($item); break;
        }
        return $item;
    }

// ==================================================================== //

    private function eventGetPagebar($item){

        if($item[0]<=$item[2])return $item;

        if(cmsCore::inRequest('of_load_more'))return $item;
        
        $components = explode(',', $this->config['Компоненты через запятую']);
        $component  = cmsCore::getInstance()->component;
        
        if(!in_array($component, $components))return $item;
        
        cmsPage::getInstance()->addHeadJS('plugins/p_load_more/js/common.js?v=10');
        cmsPage::getInstance()->addHeadJS('includes/jquery/jquery.scrollTo.min.js');
        cmsPage::getInstance()->addHeadJS('includes/jquery/history.min.js');
        echo "<script type=\"text/javascript\">
        $(document).ready(function(){
            if($('.component .float_bar .ajaxlink').length>0)return false;
            load_more.otstup    = ".$this->config['Отступ сверху до появления PageBar'].";
            load_more.start_load= ".$this->config['Осталось пикселей для начала загрузки'].";
            load_more.can_stop  = ".$this->config['Разрешить прекращать подгрузку'].";
            load_more.init('".cmsCore::getInstance()->component."');
        });
        </script>";
        
        return $item;

    }

// ==================================================================== //
    
    private function eventAfterComponent($item){
        if(!cmsCore::inRequest('of_load_more'))return $item;
        echo $item;
        exit;
    }

// ==================================================================== //

}

?>